# coding=utf-8
# *** WARNING: this file was generated by the Pulumi SDK Generator. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from ... import _utilities

__all__ = [
    'ListCognitiveServicesAccountKeysResult',
    'AwaitableListCognitiveServicesAccountKeysResult',
    'list_cognitive_services_account_keys',
    'list_cognitive_services_account_keys_output',
]

@pulumi.output_type
class ListCognitiveServicesAccountKeysResult:
    """
    The access keys for the cognitive services account.
    """
    def __init__(__self__, key1=None, key2=None):
        if key1 and not isinstance(key1, str):
            raise TypeError("Expected argument 'key1' to be a str")
        pulumi.set(__self__, "key1", key1)
        if key2 and not isinstance(key2, str):
            raise TypeError("Expected argument 'key2' to be a str")
        pulumi.set(__self__, "key2", key2)

    @property
    @pulumi.getter
    def key1(self) -> Optional[str]:
        """
        Gets the value of key 1.
        """
        return pulumi.get(self, "key1")

    @property
    @pulumi.getter
    def key2(self) -> Optional[str]:
        """
        Gets the value of key 2.
        """
        return pulumi.get(self, "key2")


class AwaitableListCognitiveServicesAccountKeysResult(ListCognitiveServicesAccountKeysResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return ListCognitiveServicesAccountKeysResult(
            key1=self.key1,
            key2=self.key2)


def list_cognitive_services_account_keys(account_name: Optional[str] = None,
                                         resource_group_name: Optional[str] = None,
                                         opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableListCognitiveServicesAccountKeysResult:
    """
    The access keys for the cognitive services account.


    :param str account_name: The name of the cognitive services account within the specified resource group. Cognitive Services account names must be between 3 and 24 characters in length and use numbers and lower-case letters only.  
    :param str resource_group_name: The name of the resource group within the user's subscription.
    """
    __args__ = dict()
    __args__['accountName'] = account_name
    __args__['resourceGroupName'] = resource_group_name
    if opts is None:
        opts = pulumi.InvokeOptions()
    if opts.version is None:
        opts.version = _utilities.get_version()
    __ret__ = pulumi.runtime.invoke('azure-native:cognitiveservices/v20160201preview:listCognitiveServicesAccountKeys', __args__, opts=opts, typ=ListCognitiveServicesAccountKeysResult).value

    return AwaitableListCognitiveServicesAccountKeysResult(
        key1=__ret__.key1,
        key2=__ret__.key2)


@_utilities.lift_output_func(list_cognitive_services_account_keys)
def list_cognitive_services_account_keys_output(account_name: Optional[pulumi.Input[str]] = None,
                                                resource_group_name: Optional[pulumi.Input[str]] = None,
                                                opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[ListCognitiveServicesAccountKeysResult]:
    """
    The access keys for the cognitive services account.


    :param str account_name: The name of the cognitive services account within the specified resource group. Cognitive Services account names must be between 3 and 24 characters in length and use numbers and lower-case letters only.  
    :param str resource_group_name: The name of the resource group within the user's subscription.
    """
    ...
