# coding=utf-8
# *** WARNING: this file was generated by the Pulumi SDK Generator. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from ... import _utilities
from ._enums import *

__all__ = ['IscsiDiskArgs', 'IscsiDisk']

@pulumi.input_type
class IscsiDiskArgs:
    def __init__(__self__, *,
                 access_control_records: pulumi.Input[Sequence[pulumi.Input[str]]],
                 data_policy: pulumi.Input['DataPolicy'],
                 device_name: pulumi.Input[str],
                 disk_status: pulumi.Input['DiskStatus'],
                 iscsi_server_name: pulumi.Input[str],
                 manager_name: pulumi.Input[str],
                 monitoring_status: pulumi.Input['MonitoringStatus'],
                 provisioned_capacity_in_bytes: pulumi.Input[float],
                 resource_group_name: pulumi.Input[str],
                 description: Optional[pulumi.Input[str]] = None,
                 disk_name: Optional[pulumi.Input[str]] = None):
        """
        The set of arguments for constructing a IscsiDisk resource.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] access_control_records: The access control records.
        :param pulumi.Input['DataPolicy'] data_policy: The data policy.
        :param pulumi.Input[str] device_name: The device name.
        :param pulumi.Input['DiskStatus'] disk_status: The disk status.
        :param pulumi.Input[str] iscsi_server_name: The iSCSI server name.
        :param pulumi.Input[str] manager_name: The manager name
        :param pulumi.Input['MonitoringStatus'] monitoring_status: The monitoring.
        :param pulumi.Input[float] provisioned_capacity_in_bytes: The provisioned capacity in bytes.
        :param pulumi.Input[str] resource_group_name: The resource group name
        :param pulumi.Input[str] description: The description.
        :param pulumi.Input[str] disk_name: The disk name.
        """
        pulumi.set(__self__, "access_control_records", access_control_records)
        pulumi.set(__self__, "data_policy", data_policy)
        pulumi.set(__self__, "device_name", device_name)
        pulumi.set(__self__, "disk_status", disk_status)
        pulumi.set(__self__, "iscsi_server_name", iscsi_server_name)
        pulumi.set(__self__, "manager_name", manager_name)
        pulumi.set(__self__, "monitoring_status", monitoring_status)
        pulumi.set(__self__, "provisioned_capacity_in_bytes", provisioned_capacity_in_bytes)
        pulumi.set(__self__, "resource_group_name", resource_group_name)
        if description is not None:
            pulumi.set(__self__, "description", description)
        if disk_name is not None:
            pulumi.set(__self__, "disk_name", disk_name)

    @property
    @pulumi.getter(name="accessControlRecords")
    def access_control_records(self) -> pulumi.Input[Sequence[pulumi.Input[str]]]:
        """
        The access control records.
        """
        return pulumi.get(self, "access_control_records")

    @access_control_records.setter
    def access_control_records(self, value: pulumi.Input[Sequence[pulumi.Input[str]]]):
        pulumi.set(self, "access_control_records", value)

    @property
    @pulumi.getter(name="dataPolicy")
    def data_policy(self) -> pulumi.Input['DataPolicy']:
        """
        The data policy.
        """
        return pulumi.get(self, "data_policy")

    @data_policy.setter
    def data_policy(self, value: pulumi.Input['DataPolicy']):
        pulumi.set(self, "data_policy", value)

    @property
    @pulumi.getter(name="deviceName")
    def device_name(self) -> pulumi.Input[str]:
        """
        The device name.
        """
        return pulumi.get(self, "device_name")

    @device_name.setter
    def device_name(self, value: pulumi.Input[str]):
        pulumi.set(self, "device_name", value)

    @property
    @pulumi.getter(name="diskStatus")
    def disk_status(self) -> pulumi.Input['DiskStatus']:
        """
        The disk status.
        """
        return pulumi.get(self, "disk_status")

    @disk_status.setter
    def disk_status(self, value: pulumi.Input['DiskStatus']):
        pulumi.set(self, "disk_status", value)

    @property
    @pulumi.getter(name="iscsiServerName")
    def iscsi_server_name(self) -> pulumi.Input[str]:
        """
        The iSCSI server name.
        """
        return pulumi.get(self, "iscsi_server_name")

    @iscsi_server_name.setter
    def iscsi_server_name(self, value: pulumi.Input[str]):
        pulumi.set(self, "iscsi_server_name", value)

    @property
    @pulumi.getter(name="managerName")
    def manager_name(self) -> pulumi.Input[str]:
        """
        The manager name
        """
        return pulumi.get(self, "manager_name")

    @manager_name.setter
    def manager_name(self, value: pulumi.Input[str]):
        pulumi.set(self, "manager_name", value)

    @property
    @pulumi.getter(name="monitoringStatus")
    def monitoring_status(self) -> pulumi.Input['MonitoringStatus']:
        """
        The monitoring.
        """
        return pulumi.get(self, "monitoring_status")

    @monitoring_status.setter
    def monitoring_status(self, value: pulumi.Input['MonitoringStatus']):
        pulumi.set(self, "monitoring_status", value)

    @property
    @pulumi.getter(name="provisionedCapacityInBytes")
    def provisioned_capacity_in_bytes(self) -> pulumi.Input[float]:
        """
        The provisioned capacity in bytes.
        """
        return pulumi.get(self, "provisioned_capacity_in_bytes")

    @provisioned_capacity_in_bytes.setter
    def provisioned_capacity_in_bytes(self, value: pulumi.Input[float]):
        pulumi.set(self, "provisioned_capacity_in_bytes", value)

    @property
    @pulumi.getter(name="resourceGroupName")
    def resource_group_name(self) -> pulumi.Input[str]:
        """
        The resource group name
        """
        return pulumi.get(self, "resource_group_name")

    @resource_group_name.setter
    def resource_group_name(self, value: pulumi.Input[str]):
        pulumi.set(self, "resource_group_name", value)

    @property
    @pulumi.getter
    def description(self) -> Optional[pulumi.Input[str]]:
        """
        The description.
        """
        return pulumi.get(self, "description")

    @description.setter
    def description(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "description", value)

    @property
    @pulumi.getter(name="diskName")
    def disk_name(self) -> Optional[pulumi.Input[str]]:
        """
        The disk name.
        """
        return pulumi.get(self, "disk_name")

    @disk_name.setter
    def disk_name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "disk_name", value)


class IscsiDisk(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 access_control_records: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 data_policy: Optional[pulumi.Input['DataPolicy']] = None,
                 description: Optional[pulumi.Input[str]] = None,
                 device_name: Optional[pulumi.Input[str]] = None,
                 disk_name: Optional[pulumi.Input[str]] = None,
                 disk_status: Optional[pulumi.Input['DiskStatus']] = None,
                 iscsi_server_name: Optional[pulumi.Input[str]] = None,
                 manager_name: Optional[pulumi.Input[str]] = None,
                 monitoring_status: Optional[pulumi.Input['MonitoringStatus']] = None,
                 provisioned_capacity_in_bytes: Optional[pulumi.Input[float]] = None,
                 resource_group_name: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        """
        The iSCSI disk.

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] access_control_records: The access control records.
        :param pulumi.Input['DataPolicy'] data_policy: The data policy.
        :param pulumi.Input[str] description: The description.
        :param pulumi.Input[str] device_name: The device name.
        :param pulumi.Input[str] disk_name: The disk name.
        :param pulumi.Input['DiskStatus'] disk_status: The disk status.
        :param pulumi.Input[str] iscsi_server_name: The iSCSI server name.
        :param pulumi.Input[str] manager_name: The manager name
        :param pulumi.Input['MonitoringStatus'] monitoring_status: The monitoring.
        :param pulumi.Input[float] provisioned_capacity_in_bytes: The provisioned capacity in bytes.
        :param pulumi.Input[str] resource_group_name: The resource group name
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: IscsiDiskArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        The iSCSI disk.

        :param str resource_name: The name of the resource.
        :param IscsiDiskArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(IscsiDiskArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 access_control_records: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 data_policy: Optional[pulumi.Input['DataPolicy']] = None,
                 description: Optional[pulumi.Input[str]] = None,
                 device_name: Optional[pulumi.Input[str]] = None,
                 disk_name: Optional[pulumi.Input[str]] = None,
                 disk_status: Optional[pulumi.Input['DiskStatus']] = None,
                 iscsi_server_name: Optional[pulumi.Input[str]] = None,
                 manager_name: Optional[pulumi.Input[str]] = None,
                 monitoring_status: Optional[pulumi.Input['MonitoringStatus']] = None,
                 provisioned_capacity_in_bytes: Optional[pulumi.Input[float]] = None,
                 resource_group_name: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        if opts is None:
            opts = pulumi.ResourceOptions()
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.version is None:
            opts.version = _utilities.get_version()
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = IscsiDiskArgs.__new__(IscsiDiskArgs)

            if access_control_records is None and not opts.urn:
                raise TypeError("Missing required property 'access_control_records'")
            __props__.__dict__["access_control_records"] = access_control_records
            if data_policy is None and not opts.urn:
                raise TypeError("Missing required property 'data_policy'")
            __props__.__dict__["data_policy"] = data_policy
            __props__.__dict__["description"] = description
            if device_name is None and not opts.urn:
                raise TypeError("Missing required property 'device_name'")
            __props__.__dict__["device_name"] = device_name
            __props__.__dict__["disk_name"] = disk_name
            if disk_status is None and not opts.urn:
                raise TypeError("Missing required property 'disk_status'")
            __props__.__dict__["disk_status"] = disk_status
            if iscsi_server_name is None and not opts.urn:
                raise TypeError("Missing required property 'iscsi_server_name'")
            __props__.__dict__["iscsi_server_name"] = iscsi_server_name
            if manager_name is None and not opts.urn:
                raise TypeError("Missing required property 'manager_name'")
            __props__.__dict__["manager_name"] = manager_name
            if monitoring_status is None and not opts.urn:
                raise TypeError("Missing required property 'monitoring_status'")
            __props__.__dict__["monitoring_status"] = monitoring_status
            if provisioned_capacity_in_bytes is None and not opts.urn:
                raise TypeError("Missing required property 'provisioned_capacity_in_bytes'")
            __props__.__dict__["provisioned_capacity_in_bytes"] = provisioned_capacity_in_bytes
            if resource_group_name is None and not opts.urn:
                raise TypeError("Missing required property 'resource_group_name'")
            __props__.__dict__["resource_group_name"] = resource_group_name
            __props__.__dict__["local_used_capacity_in_bytes"] = None
            __props__.__dict__["name"] = None
            __props__.__dict__["type"] = None
            __props__.__dict__["used_capacity_in_bytes"] = None
        alias_opts = pulumi.ResourceOptions(aliases=[pulumi.Alias(type_="azure-nextgen:storsimple/v20161001:IscsiDisk")])
        opts = pulumi.ResourceOptions.merge(opts, alias_opts)
        super(IscsiDisk, __self__).__init__(
            'azure-native:storsimple/v20161001:IscsiDisk',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None) -> 'IscsiDisk':
        """
        Get an existing IscsiDisk resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = IscsiDiskArgs.__new__(IscsiDiskArgs)

        __props__.__dict__["access_control_records"] = None
        __props__.__dict__["data_policy"] = None
        __props__.__dict__["description"] = None
        __props__.__dict__["disk_status"] = None
        __props__.__dict__["local_used_capacity_in_bytes"] = None
        __props__.__dict__["monitoring_status"] = None
        __props__.__dict__["name"] = None
        __props__.__dict__["provisioned_capacity_in_bytes"] = None
        __props__.__dict__["type"] = None
        __props__.__dict__["used_capacity_in_bytes"] = None
        return IscsiDisk(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="accessControlRecords")
    def access_control_records(self) -> pulumi.Output[Sequence[str]]:
        """
        The access control records.
        """
        return pulumi.get(self, "access_control_records")

    @property
    @pulumi.getter(name="dataPolicy")
    def data_policy(self) -> pulumi.Output[str]:
        """
        The data policy.
        """
        return pulumi.get(self, "data_policy")

    @property
    @pulumi.getter
    def description(self) -> pulumi.Output[Optional[str]]:
        """
        The description.
        """
        return pulumi.get(self, "description")

    @property
    @pulumi.getter(name="diskStatus")
    def disk_status(self) -> pulumi.Output[str]:
        """
        The disk status.
        """
        return pulumi.get(self, "disk_status")

    @property
    @pulumi.getter(name="localUsedCapacityInBytes")
    def local_used_capacity_in_bytes(self) -> pulumi.Output[float]:
        """
        The local used capacity in bytes.
        """
        return pulumi.get(self, "local_used_capacity_in_bytes")

    @property
    @pulumi.getter(name="monitoringStatus")
    def monitoring_status(self) -> pulumi.Output[str]:
        """
        The monitoring.
        """
        return pulumi.get(self, "monitoring_status")

    @property
    @pulumi.getter
    def name(self) -> pulumi.Output[str]:
        """
        The name.
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter(name="provisionedCapacityInBytes")
    def provisioned_capacity_in_bytes(self) -> pulumi.Output[float]:
        """
        The provisioned capacity in bytes.
        """
        return pulumi.get(self, "provisioned_capacity_in_bytes")

    @property
    @pulumi.getter
    def type(self) -> pulumi.Output[str]:
        """
        The type.
        """
        return pulumi.get(self, "type")

    @property
    @pulumi.getter(name="usedCapacityInBytes")
    def used_capacity_in_bytes(self) -> pulumi.Output[float]:
        """
        The used capacity in bytes.
        """
        return pulumi.get(self, "used_capacity_in_bytes")

